#include<bits/stdc++.h>
using namespace std;

long long a[100000];

int main()
{
    long long N, K;
    long long ans = 0;

    cin >> N >> K;

    for(int i = 0; i < N; i++)
    {
        cin >> a[i];
    }

    for(int i = 0; i < N; i++)
    {
        long long pl = a[i]|a[i+1];
        if(pl) ans++;

        for(int j = i+2; j < N; j++)
        {
            cout << i << " " << j << endl;
            pl = pl|a[j];
            if(pl|a[j])
            {
                cout << i << " " << j << endl;
                ans++;
                //break;
            }
        }
    }

    cout << ans << endl;

    return 0;
}


